// Bulb for pinapple lamp
$fa=0.5; // default minimum facet angle is now 0.5
$fs=0.5; // default minimum facet size is now 0.5 mm
difference()
{
  // Main body
  linear_extrude(120)
  polygon(points=[[-25.5,0],[-18.5,18.5],[0,25.5],[18.5,18.5],[25.5,0],[18.5,-18.5],[0,-25.5],[-18.5,-18.5]]);
  // Subtract inner cylinder
  cylinder(r=22.5,h=125);
  // Subtract four long grooves for mounting bulb on pineapple lamp
  translate([-2.5,-25.5,-10])
  cube([5,52,50]);
  translate([-25.5,-2.5,-10])
  cube([52,5,50]);
  // Subtract four smaller grooves for mounting bulb on pineapple lamp
  translate([-23.5,-30.5,-10])
  rotate([0,0,45])
  {
    cube([70,10,20]);
  }
  translate([-23.5,30.5,-10])
  rotate([0,0,225])
  {
    cube([10,70,20]);    
  }
  
  // Holes for cables
  rotate([90,0,5])
  {
     translate([-1.5,68,-1.5]) 
     cylinder(r=1.5,h=100);
  }    
  rotate([90,0,50])
  {
     translate([-1.5,68,-1.5]) 
     cylinder(r=1.5,h=100);
  }
  rotate([90,0,95])
  {
     translate([-1.5,68,-1.5]) 
     cylinder(r=1.5,h=100);
  }
  rotate([90,0,140])
  {
     translate([-1.5,68,-1.5]) 
     cylinder(r=1.5,h=100);
  }  
  rotate([90,0,185])
  {
     translate([-1.5,68,-1.5]) 
     cylinder(r=1.5,h=100);
  }  
  rotate([90,0,230])
  {
     translate([-1.5,68,-1.5]) 
     cylinder(r=1.5,h=100);
  } 
  rotate([90,0,275])
  {
     translate([-1.5,68,-1.5]) 
     cylinder(r=1.5,h=100);
  } 
  rotate([90,0,320])
  {
     translate([-1.5,68,-1.5]) 
     cylinder(r=1.5,h=100);
  }    
}
// Holder for ESP32 PICO Board
rotate([0,0,45])
{
  difference()
  {
    translate([-2,-23.5,93])
    cube([4,47,7]);
    translate([-2,-9.5,93])
    cube([4,18,7]);
    translate([-1,-10.5,93])
    cube([2,20,7]);     
  }   
}
